#!/bin/sh
# $Id: t-batv-cnf-0.sh,v 1.2 2005/03/08 23:04:15 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#

# ---------------------------
# run t-batv-cnf-0 with some configuration files
# ---------------------------

test -s stop && exit 1              

PRG=t-batv-cnf-0
IN=${PRG}.in
OUT=${PRG}.out
OK=${PRG}.ok

TEST=1
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
key { number = 1; private = "abdasfd"; }
key { number = 3; private = "this is another key"; }
EOF
cat > ${OK} <<EOF
key=1, private='abdasfd'
key=3, private='this is another key'
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if grep SM_USE_BATV ${OUT}
then
  exit 0
fi
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

TEST=2
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
key { number = 9; private = "01234567890123456789"; }
key { number = 2; private = "This is JUST anOther key!"; }
EOF
cat > ${OK} <<EOF
key=9, private='01234567890123456789'
key=2, private='This is JUST anOther key!'
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

TEST=3
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
key { number = 1;  }
key { private = "This is JUST anOther key!"; }
EOF
cat > ${OK} <<EOF
${IN}: not found
${IN}: ${IN}:1: private: missing property
${IN}: ${IN}:2: number: missing property
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

TEST=4
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
key { number = 10; private = "This is JUST anOther key!"; }
EOF
cat > ${OK} <<EOF
${IN}: invalid value
${IN}: ${IN}:1: overflow error in number '10'
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

rm -f ${IN} ${OUT} ${OK}
exit 0
