/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: sockcnfdef.h,v 1.3 2005/05/31 21:14:46 ca Exp $
 */

#ifndef SM_SOCKCNFDEF_H
#define SM_SOCKCNFDEF_H 1

#include "sm/generic.h"
#include "sm/net.h"
#include "sm/sm-conf.h"

typedef struct sockspec_S sockspec_T, *sockspec_P;
struct sockspec_S
{
	short	 sckspc_type;
	short	 sckspc_port;
	ipv4_T	 sckspc_addr;
	char	*sckspc_host;
};

sm_conf_definition_T const sock_types[] =
{
{ SM_CONF_DEF_MAGIC, "inet",	sm_conf_type_choice_value, 0x01	},
{ SM_CONF_DEF_MAGIC, "unix",	sm_conf_type_choice_value, 0x02 },
{ SM_CONF_DEF_MAGIC, "inet6",	sm_conf_type_choice_value, 0x04	},

/* Sentinel */
{ SM_CONF_DEF_MAGIC, NULL, 0, 0, 0, NULL, 0, NULL, NULL, NULL, NULL }
};

static sm_conf_definition_T sock_spec_defs[] =
{
	{ SM_CONF_DEF_MAGIC, "type", sm_conf_type_choice,
		offsetof(sockspec, sckspc_type),
		sizeof(short),
		"inet", SM_CONF_FLAG_KEEP_DEFAULT, sock_types
	},

	{ SM_CONF_DEF_MAGIC, "port", sm_conf_type_u32,
		offsetof(sockspec, sckspc_port),
		sizeof(short),
		"1234", SM_CONF_FLAG_KEEP_DEFAULT
	},

	{ SM_CONF_DEF_MAGIC, "address", sm_conf_type_ipv4,
		offsetof(sockspec, sckspc_addr),
		sizeof(ipv4_T),
		"127.0.0.1", SM_CONF_FLAG_KEEP_DEFAULT
	},

	{ SM_CONF_DEF_MAGIC, "host", sm_conf_type_string,
		offsetof(sockspec, sckspc_host),
		0,
		NULL, 0
	},

	/* Sentinel */
	{ SM_CONF_DEF_MAGIC, NULL, 0, 0, 0, NULL, 0, NULL, NULL, NULL, NULL }
};

#undef EXTERN 

#endif /* SM_SOCKCNFDEF_H */
